"============================================================================
"File:        rpmlint.vim
"Description: Syntax checking plugin for syntastic.vim
"Maintainer:  LCD 47 <lcd047 at gmail dot com>
"License:     This program is free software. It comes without any warranty,
"             to the extent permitted by applicable law. You can redistribute
"             it and/or modify it under the terms of the Do What The Fuck You
"             Want To Public License, Version 2, as published by Sam Hocevar.
"             See http://sam.zoy.org/wtfpl/COPYING for more details.
"
"============================================================================

if exists('g:loaded_syntastic_spec_rpmlint_checker')
    finish
endif
let g:loaded_syntastic_spec_rpmlint_checker = 1

let s:save_cpo = &cpo
set cpo&vim

function! SyntaxCheckers_spec_rpmlint_GetLocList() dict
    let makeprg = self.makeprgBuild({})

    let errorformat =
        \ '%E%f:%l: E: %m,' .
        \ '%E%f: E: %m,' .
        \ '%W%f:%l: W: %m,' .
        \ '%W%f: W: %m,' .
        \ '%-G%.%#'

    return SyntasticMake({
        \ 'makeprg': makeprg,
        \ 'errorformat': errorformat })
endfunction

call g:SyntasticRegistry.CreateAndRegisterChecker({
    \ 'filetype': 'spec',
    \ 'name': 'rpmlint'})

let &cpo = s:save_cpo
unlet s:save_cpo

" vim: set et sts=4 sw=4:
